#include <math.h>
#include <iostream.h>
#include "states.h"
#include "3dengine.h"

car_start::car_start()
{
	Name = "car start";

	Manager.load_map("data/plate.ase");
	City = Manager.Maps.back();
	Manager.load_map("data/car.ase");
	Car = Manager.Maps.back();
	Manager.load_image("data/env.png");
	Environ = Manager.Images.back();

	for(size_t i = 0; i < Car->VertexCount; i++)
		Car->Vertices[i].y += 11.8863;
	for(size_t i = 0; i < City->VertexCount; i++)
		City->Vertices[i].y += 11.8863;
}

car_start::~car_start()
{
}

void car_start::on_enter(void* Parameter)
{
	glCullFace(GL_FRONT);
}

void car_start::on_leave()
{
}

void car_start::display_func()
{
	float Time = sys_timer() - TIME(8);

	if(Time >= TIME(8))
	{
		leave();
		return;
	}

	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glDisable(GL_BLEND);

	glEnable(GL_TEXTURE_2D);

	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective(90, 4.0 / 3.0, 10, 10000);

	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	bil::vector Camera;
	
	END(2)
	{
		Camera = bil::vector(100 - ((Time - TIME(8)) / TIME(1)) * 50, 50, 100 - (Time / TIME(1)) * 100);
	}
	else END(4)
	{
		Camera = bil::vector(100 - ((Time - TIME(10)) / TIME(1)) * 100, 50, 100);
	}
	else END(6)
	{
		Camera = bil::vector(50, 100 - ((Time - TIME(12)) / TIME(1)) * 50, 0);
	}
	else END(8)
	{
		Camera = bil::vector(-100 + ((Time - TIME(14)) / TIME(1)) * 100, 50, -100);
	}

	gluLookAt(Camera.x, Camera.y + 12, Camera.z, 0, 0, 0, 0, 1, 0);
	Camera.normalize();

	glEnable(GL_CULL_FACE);
	glEnable(GL_DEPTH_TEST);

	glScalef(1, -1, 1);
	glCullFace(GL_BACK);
	Car->render();
	
	glScalef(1, -1, 1);
	glCullFace(GL_FRONT);

	glEnable(GL_BLEND);
	glBlendFunc(GL_ONE, GL_ONE);	
	City->render();
	glDisable(GL_BLEND);
	Car->render();

	glDisable(GL_CULL_FACE);
	glDisable(GL_DEPTH_TEST);
	glEnable(GL_BLEND);

	image::set(NULL);

	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	glBlendFunc(GL_ONE, GL_ONE_MINUS_SRC_COLOR);

	END(1)
	{
		glBlendFunc(GL_SRC_ALPHA, GL_ONE);	
	
		glColor4f(1, 1, 1, 1 - Time / TIME(1));
		glBegin(GL_QUADS);
		glVertex3f(-1, -1, 0.5f);
		glVertex3f( 1, -1, 0.5f);
		glVertex3f( 1,  1, 0.5f);
		glVertex3f(-1,  1, 0.5f);
		glEnd();
	}
}

